ghc-7.0.3: The GHC API

CmmCPSGen

Synopsis

- continuationToProc :: (WordOff, WordOff, [(CLabel, ContinuationFormat)]) -> CmmReg -> [[[Unique]]] -> Continuation CmmInfo -> CmmTop
- data Continuation info = Continuation info CLabel CmmFormals Bool [BrokenBlock]
- continuationLabel :: Continuation (Either C_SRT CmmInfo) -> CLabel
- data ContinuationFormat = ContinuationFormat {
  - continuation_formals :: CmmFormals
  - continuation_label :: Maybe CLabel
  - continuation_frame_size :: WordOff
  - continuation_stack :: [Maybe LocalReg]
  }

# Documentation

Converts continuations into full proceedures. The main work of the CPS transform that everything else is setting-up.

continuationToProc :: (WordOff, WordOff, [(CLabel, ContinuationFormat)]) -> CmmReg -> [[[Unique]]] -> Continuation CmmInfo -> CmmTop

data Continuation info

Constructors

Continuation info CLabel CmmFormals Bool [BrokenBlock] |

continuationLabel :: Continuation (Either C_SRT CmmInfo) -> CLabel

data ContinuationFormat

Constructors

ContinuationFormat |

Fields

continuation_formals :: CmmFormals
continuation_label :: Maybe CLabel
continuation_frame_size :: WordOff
continuation_stack :: [Maybe LocalReg]